package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.LandMarkLevel;
import com.izouma.awesomeadmin.service.LandMarkLevelService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/landMarkLevel")
public class LandMarkLevelController {

    @Autowired
    private LandMarkLevelService landMarkLevelService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(LandMarkLevel record) {
        List<LandMarkLevel> pp = landMarkLevelService.getLandMarkLevelList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getLandMarkLevel", method = RequestMethod.GET)
    @ResponseBody
    public Result getLandMarkLevel(@RequestParam(required = false, value = "id") String id) {
        LandMarkLevel data = landMarkLevelService.getLandMarkLevelById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(LandMarkLevel record) {
        LandMarkLevel data = landMarkLevelService.getLandMarkLevel(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, LandMarkLevel record) {
        Map<String, Object> result = new HashMap<>();

        List<LandMarkLevel> pp =landMarkLevelService.getLandMarkLevelByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(LandMarkLevel record) {
        boolean num = landMarkLevelService.createLandMarkLevel(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateLandMarkLevel(LandMarkLevel record) {
        boolean num = landMarkLevelService.updateLandMarkLevel(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteLandMarkLevel(LandMarkLevel record) {

        boolean num = landMarkLevelService.deleteLandMarkLevel(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, LandMarkLevel record) throws Exception {

    List<LandMarkLevel> landMarkLevels = landMarkLevelService.getLandMarkLevelList(record);


        String sheetName = "land_mark_level";
        String titleName = "地标信息层级表数据表";
        String fileName = "地标信息层级表表";
        int columnNumber = 16;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "名称" ,   "所属城市ID" ,   "上一级" ,   "地标信息ID" ,   "是否顶级" ,   "经度" ,   "纬度" ,   "备注1" ,   "备注2" ,   "备注3"  };
        String[][] dataList = new String[landMarkLevels.size()][16];

        for (int i = 0; i < landMarkLevels.size(); i++) {

                        dataList[i][0] = String.valueOf(landMarkLevels.get(i).getId());
                        dataList[i][1] = String.valueOf(landMarkLevels.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(landMarkLevels.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(landMarkLevels.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(landMarkLevels.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(landMarkLevels.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(landMarkLevels.get(i).getName());
                        dataList[i][7] = String.valueOf(landMarkLevels.get(i).getOwnedCityId());
                        dataList[i][8] = String.valueOf(landMarkLevels.get(i).getFrontLevelId());
                        dataList[i][9] = String.valueOf(landMarkLevels.get(i).getLandMarkId());
                        dataList[i][10] = String.valueOf(landMarkLevels.get(i).getTopLevel());
                        dataList[i][11] = String.valueOf(landMarkLevels.get(i).getLongitude());
                        dataList[i][12] = String.valueOf(landMarkLevels.get(i).getLatitude());
                        dataList[i][13] = String.valueOf(landMarkLevels.get(i).getRemark1());
                        dataList[i][14] = String.valueOf(landMarkLevels.get(i).getRemark2());
                        dataList[i][15] = String.valueOf(landMarkLevels.get(i).getRemark3());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

